FLTK 1.4.5: Fl_Image Class Reference

FLTK 1.4.5

Loading...
Searching...
No Matches
Fl_Image Class Reference

Base class for image caching, scaling and drawing. More...

`#include <Fl_Image.H>`

Inheritance diagram for Fl_Image:

## Public Member Functions
virtual class Fl_Shared_Image * | as_shared_image ()
| Returns whether an image is an Fl_Shared_Image or not.
virtual void | color_average (Fl_Color c, float i)
| The color_average() method averages the colors in the image with the provided FLTK color value.
Fl_Image * | copy () const
| Creates a copy of the image in the same size.
virtual Fl_Image * | copy (int W, int H) const
| Creates a resized copy of the image.
int | count () const
| Returns the number of data values associated with the image.
int | d () const
| Returns the image depth.
const char *const * | data () const
| Returns a pointer to the current image data array.
int | data_h () const
| Returns the height of the image data.
int | data_w () const
| Returns the width of the image data.
virtual void | desaturate ()
| The desaturate() method converts an image to grayscale.
void | draw (int X, int Y)
| Draws the image to the current drawing surface.
virtual void | draw (int X, int Y, int W, int H, int cx=0, int cy=0)
| Draws the image to the current drawing surface with a bounding box.
int | fail () const
| Returns a value that is not 0 if there is currently no image available.
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth.
int | h () const
| Returns the current image drawing height in FLTK units.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.
virtual void | label (Fl_Menu_Item *m)
| This method is an obsolete way to set the image attribute of a menu item.
virtual void | label (Fl_Widget *w)
| This method is an obsolete way to set the image attribute of a widget or menu item.
int | ld () const
| Returns the current line data size in bytes.
virtual void | release ()
| Releases an Fl_Image - the same as '`delete` `this'`.
virtual void | scale (int width, int height, int proportional=1, int can_expand=0)
| Sets the drawing size of the image.
virtual void | uncache ()
| If the image has been cached for display, delete the cache data.
int | w () const
| Returns the current image drawing width in FLTK units.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Static Public Member Functions
static Fl_Labeltype | define_FL_IMAGE_LABEL ()
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method.
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int).
static Fl_RGB_Scaling | scaling_algorithm ()
| Gets what algorithm is used when resizing a source image to draw it.
static void | scaling_algorithm (Fl_RGB_Scaling algorithm)
| Sets what algorithm is used when resizing a source image to draw it.

## Static Public Attributes
static const int | ERR_FILE_ACCESS = -2
static const int | ERR_FORMAT = -3
static const int | ERR_MEMORY_ACCESS = -4
static const int | ERR_NO_IMAGE = -1
static bool | register_images_done = false
| True after fl_register_images() was called, false before.

## Protected Member Functions
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current data pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it.
int | draw_scaled (int X, int Y, int W, int H)
| Draw the image to the current drawing surface rescaled to a given width and height.
void | h (int H)
| Sets the height of the image data.
void | ld (int LD)
| Sets the current line data size in bytes.
void | w (int W)
| Sets the width of the image data.

## Static Protected Member Functions
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Friends
class | Fl_Graphics_Driver

## Detailed Description

Base class for image caching, scaling and drawing.

Fl_Image is the base class used for caching, scaling and drawing all kinds of images in FLTK. This class keeps track of common image data such as the pixels, colormap, width, height, and depth. Virtual methods are used to provide type-specific image handling.

Each image possesses two (width, height) pairs:

1. The width and height of the raw image data are returned by data_w() and data_h(). These values are set when the image is created and remain unchanged.
2. The width and height of the area filled by the image when it gets drawn are returned by w() and h(). These values are equal to data_w() and data_h() when the image is created and can be changed by the scale() member function.

Since the Fl_Image class does not support image drawing by itself, calling the Fl_Image::draw() method results in a box with an X in it being drawn instead.

## Constructor & Destructor Documentation

## ◆ Fl_Image()

Fl_Image::Fl_Image | ( | int | W,
|  | int | H,
|  | int | D )

The constructor creates an empty image with the specified width, height, and depth.

The width and height are in pixels. The depth is 0 for bitmaps, 1 for pixmap (colormap) images, and 1 to 4 for color images.

## Member Function Documentation

## ◆ as_shared_image()

virtual class Fl_Shared_Image * Fl_Image::as_shared_image | ( |  | ) |
| inlinevirtual

Returns whether an image is an Fl_Shared_Image or not.

This virtual method returns a pointer to an Fl_Shared_Image if this object is an instance of Fl_Shared_Image or NULL if not. This can be used to detect if a given Fl_Image object is a shared image, i.e. derived from Fl_Shared_Image.

Since
  1.4.0

Reimplemented in Fl_Shared_Image.

## ◆ color_average()

void Fl_Image::color_average | ( | Fl_Color | c,
|  | float | i )
| virtual

The color_average() method averages the colors in the image with the provided FLTK color value.

The first argument specifies the FLTK color to be used.

The second argument specifies the amount of the original image to combine with the color, so a value of 1.0 results in no color blend, and a value of 0.0 results in a constant image of the specified color.

An internal copy is made of the original image data before changes are applied, to avoid modifying the original image data in memory.

Reimplemented in Fl_Anim_GIF_Image, Fl_Pixmap, Fl_RGB_Image, Fl_Shared_Image, Fl_SVG_Image, and Fl_Tiled_Image.

## ◆ copy() [1/2]

Fl_Image * Fl_Image::copy | ( |  | ) | const
| inline

Creates a copy of the image in the same size.

The new image should be released when you are done with it.

This does exactly the same as 'Fl_Image::copy(int W, int H) const' where `W` and `H` are the width and height of the source image, respectively. This applies also to all subclasses of Fl_Image in the FLTK library.

The following two copy() calls are equivalent:

Fl_Image *img1 = new Fl_Image(...);
// ...
Fl_Image *img2 = img1->copy();
Fl_Image *img3 = img1->copy(img1->w(), img1->h())
Fl_Image::h
void h(int H)
Sets the height of the image data.
Definition Fl_Image.H:93
Fl_Image::w
void w(int W)
Sets the width of the image data.
Definition Fl_Image.H:87
Fl_Image::copy
virtual Fl_Image * copy(int W, int H) const
Creates a resized copy of the image.
Definition Fl_Image.cxx:115

For details see 'Fl_Image::copy(int w, int h) const'.

See also
  Fl_Image::release()

Note
  Since FLTK 1.4.0 this method is 'const'. If you derive your own class from Fl_Image or any subclass your overridden methods of 'Fl_Image::copy() const' and 'Fl_Image::copy(int, int) const' must also be 'const' for inheritance to work properly. This is different than in FLTK 1.3.x and earlier where these methods have not been 'const'.

## ◆ copy() [2/2]

Fl_Image * Fl_Image::copy | ( | int | W,
|  | int | H ) const
| virtual

Creates a resized copy of the image.

It is recommended not to call this member function to reduce the size of an image to the size of the area where this image will be drawn, and to use Fl_Image::scale() instead.

The new image should be released when you are done with it.

Note: since FLTK 1.4.0 you can use Fl_Image::release() for all types of images (i.e. all subclasses of Fl_Image) instead of operator delete for Fl_Image's and Fl_Image::release() for Fl_Shared_Image's.

The new image data will be converted to the requested size. RGB images are resized using the algorithm set by Fl_Image::RGB_scaling().

For the new image the following equations are true:

- w() == data_w() == `W`
- h() == data_h() == `H`

Parameters

  [in] | W,H | Requested width and height of the new image

Note
  The returned image can be safely cast to the same image type as that of the source image provided this type is one of Fl_RGB_Image, Fl_SVG_Image, Fl_Pixmap, Fl_Bitmap, Fl_Tiled_Image, Fl_Anim_GIF_Image and Fl_Shared_Image. Returned objects copied from images of other, derived, image classes belong to the parent class appearing in this list. For example, the copy of an Fl_GIF_Image is an object of class Fl_Pixmap.
  Since FLTK 1.4.0 this method is 'const'. If you derive your own class from Fl_Image or any subclass your overridden methods of 'Fl_Image::copy() const' and 'Fl_Image::copy(int, int) const' must also be 'const' for inheritance to work properly. This is different than in FLTK 1.3.x and earlier where these methods have not been 'const'.

Reimplemented in Fl_Anim_GIF_Image, Fl_Bitmap, Fl_Pixmap, Fl_RGB_Image, Fl_Shared_Image, Fl_SVG_Image, and Fl_Tiled_Image.

## ◆ count()

int Fl_Image::count | ( |  | ) | const
| inline

Returns the number of data values associated with the image.

The value will be 0 for images with no associated data, 1 for bitmap and color images, and greater than 2 for pixmap images.

See also
  data()

## ◆ d()

int Fl_Image::d | ( |  | ) | const
| inline

Returns the image depth.

The return value will be 0 for bitmaps, 1 for pixmaps, and 1 to 4 for color images.

## ◆ data() [1/2]

const char *const * Fl_Image::data | ( |  | ) | const
| inline

Returns a pointer to the current image data array.

There can be 0, 1, or more pointers to actual image data in an image.

Use the count() method to find the size of the data array. You must not dereference the data() pointer if count() equals zero.

Note
  data() may return NULL.

Example:

Fl_RGB_Image has exactly one pointer which points at the R, G, B [, A] data array of the image. The total size of this array depends on several attributes like data_w(), data_h(), d() and ld() and is basically data_w() * data_h() * d() but there are exceptions if ld() is non-zero: see description of ld(). Since FLTK 1.4.0 w() and h() are no longer significant for the image data size if scale() has been called on the image to set a different display size.

Other image types have different numbers and types of data pointers which are implementation details and not documented here.

See also
  count(), w(), h(), data_w(), data_h(), d(), ld()

## ◆ data() [2/2]

void Fl_Image::data | ( | const char *const * | p,
|  | int | c )
| inlineprotected

Sets the current data pointer and count of pointers in the array.

There can be 0, 1, or more pointers to actual image data in an image.

See also
  const char* const* data(), count(), w(), h(), data_w(), data_h(), d(), ld()

## ◆ desaturate()

void Fl_Image::desaturate | ( |  | ) |
| virtual

The desaturate() method converts an image to grayscale.

If the image contains an alpha channel (depth = 4), the alpha channel is preserved.

An internal copy is made of the original image data before changes are applied, to avoid modifying the original image data in memory.

Reimplemented in Fl_Anim_GIF_Image, Fl_Pixmap, Fl_RGB_Image, Fl_Shared_Image, Fl_SVG_Image, and Fl_Tiled_Image.

## ◆ draw() [1/2]

void Fl_Image::draw | ( | int | X,
|  | int | Y )
| inline

Draws the image to the current drawing surface.

Parameters

  X,Y | specify the upper-lefthand corner of the image.

## ◆ draw() [2/2]

void Fl_Image::draw | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | cx = 0,
|  | int | cy = 0 )
| virtual

Draws the image to the current drawing surface with a bounding box.

Arguments X,Y,W,H specify a bounding box for the image, with the origin (upper-left corner) of the image offset by the `cx` and `cy` arguments.

Another way to see what part of the image gets drawn and where, is to consider this alternative writing producing the same output:

    fl_push_clip(X,Y,W,H);
    this->draw(X - cx, Y - cy);
    fl_pop_clip();

Repeated calls to this member function with the same image but varying W, H, cx, or cy arguments may be more efficiently processed using the above alternative writing.

Reimplemented in Fl_Anim_GIF_Image, Fl_Bitmap, Fl_Pixmap, Fl_RGB_Image, Fl_Shared_Image, Fl_SVG_Image, and Fl_Tiled_Image.

## ◆ draw_empty()

void Fl_Image::draw_empty | ( | int | X,
|  | int | Y )
| protected

The protected method draw_empty() draws a box with an X in it.

It can be used to draw any image that lacks image data.

## ◆ draw_scaled()

int Fl_Image::draw_scaled | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H )
| protected

Draw the image to the current drawing surface rescaled to a given width and height.

Intended for internal use by the FLTK library.

Parameters

  X,Y | position of the image's top-left
  W,H | width and height for the drawn image

Returns
  1

Deprecated
  Only for API compatibility with FLTK 1.3.4.

## ◆ fail()

int Fl_Image::fail | ( |  | ) | const

Returns a value that is not 0 if there is currently no image available.

Example use:

// [..]
Fl_Box box(X, Y, W, H);
Fl_JPEG_Image jpg("/tmp/foo.jpg");
switch (jpg.fail()) {
case Fl_Image::ERR_NO_IMAGE:
case Fl_Image::ERR_FILE_ACCESS:
fl_alert("/tmp/foo.jpg: %s", strerror(errno)); // shows actual os error to user
exit(1);
case Fl_Image::ERR_FORMAT:
fl_alert("/tmp/foo.jpg: couldn't decode image");
exit(1);
}
box.image(jpg);
Fl_Box
This widget simply draws its box, and possibly its label.
Definition Fl_Box.H:34
Fl_JPEG_Image
The Fl_JPEG_Image class supports loading, caching, and drawing of Joint Photographic Experts Group (J...
Definition Fl_JPEG_Image.H:30

Returns
  Image load failure if non-zero

Return values

  0 | the image was loaded successfully
  ERR_NO_IMAGE | no image was found
  ERR_FILE_ACCESS | there was a file access related error (errno should be set)
  ERR_FORMAT | image decoding failed
  ERR_MEMORY_ACCESS | image decoder tried to access memory outside of given memory block

## ◆ h() [1/2]

int Fl_Image::h | ( |  | ) | const
| inline

Returns the current image drawing height in FLTK units.

The values of h() and data_h() are identical unless scale() has been called after which they may differ.

## ◆ h() [2/2]

void Fl_Image::h | ( | int | H | ) |
| inlineprotected

Sets the height of the image data.

This protected function sets both image heights: the height of the image data returned by data_h() and the image drawing height in FLTK units returned by h().

## ◆ inactive()

void Fl_Image::inactive | ( |  | ) |
| inline

The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out.

An internal copy is made of the original image before changes are applied, to avoid modifying the original image.

Note
  The RGB color of FL_BACKGROUND_COLOR may change when the connection to the display is made. See fl_open_display().

## ◆ label() [1/2]

void Fl_Image::label | ( | Fl_Menu_Item * | m | ) |
| virtual

This method is an obsolete way to set the image attribute of a menu item.

Deprecated
  Please use Fl_Menu_Item::image() instead.

Reimplemented in Fl_Bitmap, Fl_Pixmap, and Fl_RGB_Image.

## ◆ label() [2/2]

void Fl_Image::label | ( | Fl_Widget * | widget | ) |
| virtual

This method is an obsolete way to set the image attribute of a widget or menu item.

Deprecated
  Please use Fl_Widget::image() or Fl_Widget::deimage() instead.

Reimplemented in Fl_Bitmap, Fl_Pixmap, and Fl_RGB_Image.

## ◆ ld() [1/2]

int Fl_Image::ld | ( |  | ) | const
| inline

Returns the current line data size in bytes.

See also
  ld(int)

## ◆ ld() [2/2]

void Fl_Image::ld | ( | int | LD | ) |
| inlineprotected

Sets the current line data size in bytes.

Color images may contain extra data (padding) that is included after every line of color image data and is normally not present.

If `LD` is zero, then line data size is assumed to be data_w() * d() bytes.

If `LD` is non-zero, then it must be positive and larger than data_w() * d() to account for the extra data per line.

## ◆ release()

virtual void Fl_Image::release | ( |  | ) |
| inlinevirtual

Releases an Fl_Image - the same as '`delete` `this'`.

This virtual method is for almost all image classes the same as calling

delete image;

where image is an `Fl_Image` `*` pointer.

However, for subclass Fl_Shared_Image and its subclasses this virtual method is reimplemented and maintains shared images.

This virtual method makes it possible to `destroy` all image types in the same way by calling

image->release();

Reasoning: If you have an 'Fl_Image *' base class pointer and don't know if the object is one of the class Fl_Shared_Image or any other subclass of Fl_Image (for instance Fl_RGB_Image) then you can't just use operator delete since this is not appropriate for Fl_Shared_Image objects.

The virtual method release() handles this properly.

Since
  1.4.0 in the base class Fl_Image and virtual in Fl_Shared_Image

Reimplemented in Fl_Shared_Image.

## ◆ RGB_scaling()

void Fl_Image::RGB_scaling | ( | Fl_RGB_Scaling | method | ) |
| static

Sets the RGB image scaling method used for copy(int, int).

Applies to all RGB images, defaults to FL_RGB_SCALING_NEAREST.

## ◆ scale()

void Fl_Image::scale | ( | int | width,
|  | int | height,
|  | int | proportional = 1,
|  | int | can_expand = 0 )
| virtual

Sets the drawing size of the image.

This function controls the values returned by member functions w() and h() which in turn control how the image is drawn: the full image data (whose size is given by data_w() and data_h()) are drawn scaled to an area of the drawing surface sized at w() x h() FLTK units. This can make a difference if the drawing surface has more than 1 pixel per FLTK unit because the image can be drawn at the full resolution of the drawing surface. Examples of such drawing surfaces: HiDPI displays, laser printers, PostScript files, PDF printers.

Parameters

  width,height | maximum values, in FLTK units, that w() and h() should return
  proportional | if not null, keep the values returned by w() and h() proportional to data_w() and data_h()
  can_expand | if null, the values returned by w() and h() will not be larger than data_w() and data_h(), respectively

Note
  This function generally changes the values returned by the w() and h() member functions. In contrast, the values returned by data_w() and data_h() remain unchanged.

Version
  1.4 (1.3.4 and FL_ABI_VERSION for Fl_Shared_Image only)

Example code: scale an image to fit in a box

Fl_Box *b = ... // a box
Fl_Image *img = new Fl_PNG_Image("/path/to/picture.png"); // read a picture file
// set the drawing size of the image to the size of the box keeping its aspect ratio
img->scale(b->w(), b->h());
b->image(img); // use the image as the box image
Fl_Image::scale
virtual void scale(int width, int height, int proportional=1, int can_expand=0)
Sets the drawing size of the image.
Definition Fl_Image.cxx:290
Fl_PNG_Image::Fl_PNG_Image
Fl_PNG_Image(const char *filename)
The constructor loads the named PNG image from the given png filename.
Definition Fl_PNG_Image.cxx:88

## ◆ scaling_algorithm()

void Fl_Image::scaling_algorithm | ( | Fl_RGB_Scaling | algorithm | ) |
| inlinestatic

Sets what algorithm is used when resizing a source image to draw it.

The default algorithm is FL_RGB_SCALING_BILINEAR. Drawing an Fl_Image is sometimes performed by first resizing the source image and then drawing the resized copy. This occurs, e.g., when drawing to screen under X11 without Xrender support after having called scale(). This function controls what method is used when the image to be resized is an Fl_RGB_Image.

Version
  1.4

## ◆ uncache()

void Fl_Image::uncache | ( |  | ) |
| virtual

If the image has been cached for display, delete the cache data.

This allows you to change the data used for the image and then redraw it without recreating an image object.

Reimplemented in Fl_Anim_GIF_Image, Fl_Bitmap, Fl_Pixmap, Fl_RGB_Image, and Fl_Shared_Image.

## ◆ w() [1/2]

int Fl_Image::w | ( |  | ) | const
| inline

Returns the current image drawing width in FLTK units.

The values of w() and data_w() are identical unless scale() has been called after which they may differ.

## ◆ w() [2/2]

void Fl_Image::w | ( | int | W | ) |
| inlineprotected

Sets the width of the image data.

This protected function sets both image widths: the width of the image data returned by data_w() and the image drawing width in FLTK units returned by w().

The documentation for this class was generated from the following files:

- Fl_Image.H
- Fl_Image.cxx